/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                                Copyright 2002- hiyohiyo All rights reserved.
/*---------------------------------------------------------------------------*/
#include "stdafx.h"
#include "crystalcpuid.h"
#include "BiosInfoDlg.h"
#include "wbemcli.h"     // WMI interface declarations

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

typedef HRESULT(WINAPI * _CoInitializeSecurity_)(PSECURITY_DESCRIPTOR pVoid,LONG cAuthSvc,SOLE_AUTHENTICATION_SERVICE * asAuthSvc,void * pReserved1,
DWORD dwAuthnLevel,DWORD dwImpLevel,SOLE_AUTHENTICATION_LIST * pAuthList,DWORD dwCapabilities,void * pReserved3);

CBiosInfoDlg::CBiosInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBiosInfoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBiosInfoDlg)
	m_BiosCaption = _T("");
	m_BiosDate = _T("");
	m_BiosManufacturer = _T("");
	m_BiosVersion = _T("");
	m_MotherManufacturer = _T("");
	m_MotherProduct = _T("");
	m_MotherVersion = _T("");
	m_SystemManufacturer = _T("");
	m_SystemModel = _T("");
	//}}AFX_DATA_INIT
}

void CBiosInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBiosInfoDlg)
	DDX_Text(pDX, IDC_BIOS_CAPTION, m_BiosCaption);
	DDX_Text(pDX, IDC_BIOS_DATE, m_BiosDate);
	DDX_Text(pDX, IDC_BIOS_MANUFACTURER, m_BiosManufacturer);
	DDX_Text(pDX, IDC_BIOS_VERSION, m_BiosVersion);
	DDX_Text(pDX, IDC_MOTHER_MANUFACTURER, m_MotherManufacturer);
	DDX_Text(pDX, IDC_MOTHER_PRODUCT, m_MotherProduct);
	DDX_Text(pDX, IDC_MOTHER_VERSION, m_MotherVersion);
	DDX_Text(pDX, IDC_SYSTEM_MANUFACTURER, m_SystemManufacturer);
	DDX_Text(pDX, IDC_SYSTEM_MODEL, m_SystemModel);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBiosInfoDlg, CDialog)
	//{{AFX_MSG_MAP(CBiosInfoDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CBiosInfoDlg::OnCancel() 
{
	CDialog::OnCancel();
}

void CBiosInfoDlg::OnOK() 
{
	CDialog::OnOK();
}

BOOL CBiosInfoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	try{
		HRESULT hRes = S_OK;
		ULONG   uReturned = 1;
		CString cstr;
		char text[256];

		IWbemLocator *pIWbemLocator = NULL;
		IWbemServices* pIWbemServices = NULL;
		IEnumWbemClassObject *pEnumCOMDevs = NULL;
		IWbemClassObject  *pCOMDev = NULL;

		CoInitialize( NULL );

		_CoInitializeSecurity_ CoInitializeSecurity = NULL;
		HINSTANCE hDLL = LoadLibrary( "ole32.dll" );
		if(  hDLL != NULL ){
			CoInitializeSecurity = (_CoInitializeSecurity_)GetProcAddress( hDLL, "CoInitializeSecurity" );
		}
		if(CoInitializeSecurity == NULL){
			FreeLibrary(hDLL);
			return 1;
		}
		CoInitializeSecurity(NULL, -1, NULL, NULL,
			RPC_C_AUTHN_LEVEL_PKT_PRIVACY,RPC_C_IMP_LEVEL_IMPERSONATE,
			NULL,EOAC_SECURE_REFS,NULL );
		FreeLibrary(hDLL);

		if( CoCreateInstance(CLSID_WbemLocator,NULL,
			CLSCTX_INPROC_SERVER,IID_IWbemLocator,
			(LPVOID *) &pIWbemLocator) != S_OK ){return 1;}
		if( pIWbemLocator->ConnectServer(SysAllocString(L"\\\\.\\root\\cimv2"),
			NULL,NULL,0L,0L,NULL,NULL,&pIWbemServices) != S_OK ){return 1;}
		pIWbemLocator->Release();

	/////////////////
	//BIOS
		pIWbemServices->ExecQuery(SysAllocString(L"WQL"),
			SysAllocString(L"select ReleaseDate,Version,Manufacturer,Caption,SMBIOSBIOSVersion,SMBIOSMajorVersion,SMBIOSMinorVersion from Win32_BIOS"),0,NULL,&pEnumCOMDevs);
		if( SUCCEEDED( pEnumCOMDevs->Next(2000,1,&pCOMDev,&uReturned )) && uReturned == 1){
			VARIANT  pVal;VariantClear(&pVal);
			if( pCOMDev->Get(L"ReleaseDate",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				cstr = pVal.bstrVal;
				if(cstr.GetLength() >= 8 && atoi(cstr) > 0){
					strncpy(text,(LPCSTR)cstr,4);strcpy(text+4,"/");
					strncpy(text+5,(LPCSTR)cstr+4,2);strcpy(text+7,"/");
					strncpy(text+8,(LPCSTR)cstr+6,2);strcpy(text+10,"\0");
					m_BiosDate = " ";
					m_BiosDate += text;
					m_BiosDate.Replace("190","200");
				}
				VariantClear(&pVal);
			}

			if( pCOMDev->Get(L"Version",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				m_BiosVersion = " ";
				m_BiosVersion += pVal.bstrVal;
				VariantClear(&pVal);
			}
			if( pCOMDev->Get(L"Manufacturer",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				m_BiosManufacturer = " ";
				m_BiosManufacturer += pVal.bstrVal;
				VariantClear(&pVal);
			}
			if( pCOMDev->Get(L"Caption",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				m_BiosCaption = " ";
				m_BiosCaption += pVal.bstrVal;
				VariantClear(&pVal);
			}
			/*
			if( pCOMDev->Get(L"SMBIOSBIOSVersion",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				m_BiosSMBiosVersion += pVal.bstrVal;
				VariantClear(&pVal);
			}
			if( pCOMDev->Get(L"SMBIOSMajorVersion",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				m_BiosSMVersion.Format("%d",pVal.ulVal);
				VariantClear(&pVal);
			}
			if( pCOMDev->Get(L"SMBIOSMinorVersion",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				cstr.Format(".%d",pVal.ulVal);
				m_BiosSMVersion += cstr;
			}
			*/
			pCOMDev->Release();
		}

	/////////////////
	//Computer System
		pIWbemServices->ExecQuery(SysAllocString(L"WQL"),
			SysAllocString(L"select Manufacturer,Model from Win32_ComputerSystem"),0,NULL,&pEnumCOMDevs);

		if( SUCCEEDED( pEnumCOMDevs->Next(2000,1,&pCOMDev,&uReturned )) && uReturned == 1){
			VARIANT  pVal;VariantClear(&pVal);
			if( pCOMDev->Get(L"Manufacturer",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				m_SystemManufacturer = " ";
				m_SystemManufacturer += pVal.bstrVal;
				VariantClear(&pVal);}
			if( pCOMDev->Get(L"Model",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				m_SystemModel = " ";
				m_SystemModel += pVal.bstrVal;
			}
			pCOMDev->Release();
		}
	/////////////////
	//Mother
		pIWbemServices->ExecQuery(SysAllocString(L"WQL"),
			SysAllocString(L"select Manufacturer,Product,Version from Win32_BaseBoard"),0,NULL,&pEnumCOMDevs);
		if( SUCCEEDED( pEnumCOMDevs->Next(2000,1,&pCOMDev,&uReturned )) && uReturned == 1){
			VARIANT  pVal;VariantClear(&pVal);
			if( pCOMDev->Get(L"Version",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				m_MotherVersion = " ";
				m_MotherVersion += pVal.bstrVal;
				VariantClear(&pVal);
			}
			if( pCOMDev->Get(L"Product",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				m_MotherProduct = " ";
				m_MotherProduct += pVal.bstrVal;
				VariantClear(&pVal);
			}
			if( pCOMDev->Get(L"Manufacturer",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				m_MotherManufacturer = " ";
				m_MotherManufacturer += pVal.bstrVal;
			}
			pCOMDev->Release();
		}
	}catch(...){
		MessageBox("Please Install WMI...");
	}
	UpdateData(FALSE);

	return TRUE;
}
